"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = merge;

var _isFunction = _interopRequireDefault(require("./isFunction"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function merge() {
  var object = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var other = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var finalOther = Object.keys(other).reduce(function (r, key) {
    var value = object[key];
    var otherValue = other[key]; // 如果都存在且都是函数，则先调用后者，再调用前者

    if ((0, _isFunction.default)(value) && (0, _isFunction.default)(otherValue)) {
      return _objectSpread({}, r, _defineProperty({}, key, function () {
        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        otherValue.apply(this, args);
        value.apply(this, args);
      }));
    }

    if (_typeof(otherValue) === 'object') {
      // 如果都存在且都是对象，则合并二者
      return _objectSpread({}, r, _defineProperty({}, key, _objectSpread({}, value, otherValue)));
    } // 忽略其它情况


    return _objectSpread({}, r, _defineProperty({}, key, otherValue));
  }, {});
  return _objectSpread({}, object, finalOther);
}